#include "hex_to_base64.h"
#include <string.h>
#include <assert.h>
#include <stdio.h>

void hex_to_base64_text() {
	const char test_buff1[]		="49276d206b696c6c696e6720796f757220627261696e206c696b65206120706f69736f6e6f7573206d757368726f6f6d"; 
	const char expected_buff1[]	="SSdtIGtpbGxpbmcgeW91ciBicmFpbiBsaWtlIGEgcG9pc29ub3VzIG11c2hyb29t";

	const char test_buff2[]		="4927"; 
	const char expected_buff2[]	="SSH";

	const char test_buff3[]		="49"; 
	const char expected_buff3[]	="SB";

	const char test_buff4[]		="33"; 
	const char expected_buff4[]	="z";

	char output[256];
	char* po=output;

	memset (output,'\0', 256);
	hex_to_base64(test_buff1, po, strlen(test_buff1) );
//	printf("%s\n", output);
	assert( memcmp(expected_buff1, output, strlen(expected_buff1)) == 0 );
	assert( strlen(expected_buff1) == strlen(output));
	
	// test case  when there are 2 hex'es
	memset (output,'\0', 256);
	hex_to_base64(test_buff2, po, strlen(test_buff2) );
	assert( memcmp(expected_buff2, output, strlen(expected_buff2)) == 0 );
	assert( strlen(expected_buff2) == strlen(output));

	// test case  when there is 1 hex
	memset (output,'\0', 256);
	hex_to_base64(test_buff3, po, strlen(test_buff3) );
	assert( memcmp(expected_buff3, output, strlen(expected_buff3)) == 0 );
	assert( strlen(expected_buff3) == strlen(output));

	// test case  when there is 1 char
	memset (output,'\0', 256);
	hex_to_base64(test_buff4, po, strlen(test_buff4) );
	assert( memcmp(expected_buff4, output, strlen(expected_buff4)) == 0 );
	assert( strlen(expected_buff4) == strlen(output));
}

int main() {
	hex_to_base64_text();
}